#include "gameframe.h"

//set Gstate
GAMESTATE GameFrame::setGameState(GAMESTATE state){
	if (gstate != state){
		gstate = state;
		starttime = GetNowCount();
		if (gstate == GAME_MAIN) initStage();//InitStage
	}
	return gstate;
}
void GameFrame::drawGameMain(){
	int col = GetColor(255, 255, 255);
	DrawStringToHandle(80, 20, "push X to GAMEOVER", col, smallfont);
	DrawStringToHandle(80, 60, "push C to GAMECLEAR", col, smallfont);

	int key = GetJoypadInputState(DX_INPUT_KEY_PAD1);
	if (key&PAD_INPUT_B)setGameState(GAME_OVER);
	if (key&PAD_INPUT_C)setGameState(GAME_CLEAR);
}
void GameFrame::drawGameTitle(){
	int col = GetColor(255, 0, 255);
	int w = GetDrawStringWidthToHandle("PUSH Z KEY", 12, smallfont);
	DrawStringToHandle(320 - w / 2, 300, "PUSH Z KEY", col, smallfont);
	int key = GetJoypadInputState(DX_INPUT_KEY_PAD1);
	if (key&PAD_INPUT_A) setGameState(GAME_MAIN);

}
void GameFrame::drawGameClear(){
	int col = GetColor(0, 255, 255);
	int w = GetDrawStringWidthToHandle("GAMECLEAR", 9, largefont);
	DrawStringToHandle(320 - w / 2, 160, "GAMECLEAR", col, largefont);
	if (GetNowCount() - starttime > 5000){
		setGameState(GAME_TITLE);

	}
}
void GameFrame::drawGameOver(){
	int col = GetColor(255, 0, 0);
	int w = GetDrawStringWidthToHandle("GAMEOVER", 8, largefont);
	DrawStringToHandle(320 - w / 2, 160, "GAMEOVER", col, largefont);
	if (GetNowCount() - starttime > 5000){
		setGameState(GAME_TITLE);

	}
}
unsigned int GameFrame::getAnimCnt(){
	return animcounter;
}
void GameFrame::setIdouHosei(){
	float frametime = 0;
	unsigned int s = GetNowCount();
	for (int i = 0; i < 30; i++){
		ScreenFlip();
		unsigned int e = GetNowCount();
		frametime = frametime + e - s;
		s = e;
	}
	frametime = frametime / 30;
	for (int i = 1; i < 20; i = i + 1){
		idouryou[1] = i / 16.67*frametime;
	}

}
float GameFrame::IdouHosei(int idou){
	if (idou < 0){
		return(-idouryou[-idou]);
	}
	else{
		return(idouryou[idou]);
	}
}
float GameFrame::idouryou[20];

unsigned int GameFrame::animcounter = 0;


void GameFrame::doMainLoop(int scmode){
	ChangeWindowMode(scmode);
	if (DxLib_Init() == -1)return;
	SetDrawScreen(DX_SCREEN_BACK);
	setIdouHosei();
	//CreateFont
	largefont = CreateFontToHandle(0, 100, 9, DX_FONTTYPE_EDGE);
	smallfont = CreateFontToHandle(0, 32, 9, DX_FONTTYPE_NORMAL);
	try{
		loadFiles();
	}
	catch (int errcode){
		MessageBox(NULL, "File Read Error", "Error", MB_OK);
		return;
	}


	
	setGameState(GAME_TITLE);

	//MainLoop
	while (ProcessMessage() == 0 && CheckHitKey(KEY_INPUT_ESCAPE) == 0){
		ClsDrawScreen();
		switch (gstate){
		case GAME_TITLE:
			drawGameTitle();
			break;
		case GAME_MAIN:
			drawGameMain();
			break;
		case GAME_OVER:
			drawGameOver();
			break;
		case GAME_CLEAR:
			drawGameClear();
			break;
		}
		ScreenFlip();
		animcounter = animcounter + 1;

	}
	DxLib_End();
}
